﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Comparer
{
	public partial class FieldsForm : Form
	{
		private Plug _plug;
		private event MyFieldsEventHandler updateFields;
		//private Plugin _plugin;
		private PluginProxy _pluginproxy;
		private int _indeks;
		private SettingsClass _sc;

		public FieldsForm(Plug plugf, int indeks, Size sajz, SettingsClass sc)
		{
			InitializeComponent();
			this._plug = plugf;
			this._indeks = indeks;
			this.Width = sajz.Width;
			this.Height = sajz.Height;
			this._sc = sc;
		}

		private void FieldsForm_Load( object sender, EventArgs e )
		{
			this._pluginproxy = new PluginProxy();
			this._pluginproxy.Load(  );
			this._pluginproxy.InitializePlugins( this._plug._path );
			String tmpfieldstr = this._pluginproxy.GetFields(0);
			String[] tmpfields = tmpfieldstr.Split( ';' );

			Boolean showfield = false;

			for (int i = 0; i < tmpfields.Length; i++)
			{
				showfield = false;

				if (this._plug._fields.Contains( "*" ) || this._plug._fields.Contains( ";" + i.ToString() + ";" ))
				{
					showfield = true;
				}

				this.fieldsCLB.Items.Add( tmpfields[i], showfield );
			}

			this._pluginproxy.Free();

			this.Text = this._sc.GetLangText("FieldsFormTitle");
			label1.Text = this._sc.GetLangText( "FieldsFormDesc" );
			okBtn.Text = this._sc.GetLangText( "FieldsFormOK" );
			cancelBtn.Text = this._sc.GetLangText( "FieldsFormCancel" );
			
		}

		public event MyFieldsEventHandler UpdateFields
		{
			add
			{
				updateFields += new MyFieldsEventHandler( value );
			}
			remove
			{
				updateFields -= new MyFieldsEventHandler( value );
			}
		}

		protected void OnUpdateFields( String fstr, int indeks, Size sajz )
		{
			if (!updateFields.Equals( null ))
			{
				updateFields( this, fstr, indeks, new Size(this.Width, this.Height) );
			}
		}

		private void cancelBtn_Click( object sender, EventArgs e )
		{
			this.Close();
		}

		private void okBtn_Click( object sender, EventArgs e )
		{
			int total = 0;
			String result = ";";
			
			for (int i = 0; i < fieldsCLB.Items.Count; i++)
			{				
				if (fieldsCLB.GetItemChecked(i))
				{					
					result = result + i.ToString() + ";";
					total++;
				}
			}			

			if (total == fieldsCLB.Items.Count)
			{
				result = "*";
			}

			Size sajz = new Size( this.Width, this.Height );

			OnUpdateFields(result, this._indeks, sajz);
			this.Close();
		}

		private void General_KeyPress( object sender, KeyPressEventArgs e )
		{
			if (e.KeyChar == (char) Keys.Escape)
			{
				this.Close();
			}			
		}
	}
}
