﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Comparer
{
	class LangEngine
	{		
		private Dictionary<String, String> _langdict; 

		public LangEngine()
		{			
			//
		}

		public void LoadLanguage( string filename )
		{
			this._langdict = new Dictionary<String, String>();

			if (File.Exists( filename ))
			{
				//TODO: read all strings from file
				ReadLangFile( filename );

			}
			else
			{
				//get default
				InitDefault();
			}
		}

		public String GetLangString(String key)
		{
			if (this._langdict == null)			
			{
				return "";
			}

			if (this._langdict.ContainsKey( key ))
			{
				return this._langdict[key];
			}

			return "TransErr";
		}

		private void InitDefault()
		{
			//load all default strings
			//this._langdict.Add("klucz", "wartosc");
			this._langdict.Add( "AppWinAlwaysTop", "Always on top" );
			this._langdict.Add( "AppWinCloseCompare", "Close application after starting compare tool" );
			this._langdict.Add( "AppWinResetBtn", "Reset to default" );
			this._langdict.Add( "AppWinSize", "Remember size" );
			this._langdict.Add( "AppWinGr", "Main window" );
			this._langdict.Add( "AppWinStickMode", "Stick mode by default" );
			this._langdict.Add( "Author", "fenixproductions" );
			this._langdict.Add( "ByteSuffix", " b" );
			this._langdict.Add( "CSVExportError", "CSV Export Error!" );			
			this._langdict.Add( "CSVGr", "CSV" );			
			this._langdict.Add( "CSVSaveAs", "CSV files (*.cvs)" );
			this._langdict.Add( "CSVSeparator", "Separator:" );
			this._langdict.Add( "CSVSurround", "Surround text with quotes (\")" );
			this._langdict.Add( "CSVTitle", "Choose file to export to…" );
			this._langdict.Add( "CancelBtn", "Cancel" );
			this._langdict.Add( "CmpDownBtn", "Down" );
			this._langdict.Add( "CmpExtensionsGr", "Extensions (ex. *.bmp *.jpg)" );
			this._langdict.Add( "CmpTitle", "Comparers" );
			this._langdict.Add( "CmpUpBtn", "Up" );
			this._langdict.Add( "DefaultName", "default" );
			this._langdict.Add( "DFileMenuDate", "date && time (formatted)" );
			this._langdict.Add( "DFileMenuFirstFull", "full first filename" );
			this._langdict.Add( "DFileMenuFirstShort", "short first filename" );
			this._langdict.Add( "DFileMenuSecondFull", "full second filename" );
			this._langdict.Add( "DFileMenuSecondShort", "short second filename" );
			this._langdict.Add( "DateFormatInfo", "Date formatting info" );
			this._langdict.Add( "DoubleFile", "Double files mode:" );
			this._langdict.Add( "EmptyError", "<EMPTY / ERROR>" );
			this._langdict.Add( "ExecutableDlgTitle", "Choose comparer tool EXE file" );
			this._langdict.Add( "ExecutableDlgType", "Executable files (*.exe)" );
			this._langdict.Add( "ExecutableGr", "Executable" );
			this._langdict.Add( "ExportErrorPerm", "You don't have permission to write to this file!" );
			this._langdict.Add( "ExportTitle", "Export" );
			this._langdict.Add( "FieldsFormCancel", "Cancel" );
			this._langdict.Add( "FieldsFormDesc", "Choose plugin's fields to be shown" );
			this._langdict.Add( "FieldsFormOK", "OK" );
			this._langdict.Add( "FieldsFormTitle", "Choose fields" );
			this._langdict.Add( "FilenamesGr", "Default filenames (without extensions)" );
			this._langdict.Add( "GenTitle", "General" );
			this._langdict.Add( "HTMLExportError", "HTML Export Error" );
			this._langdict.Add( "HTMLSaveAs", "HTML files (*.html)" );
			this._langdict.Add( "HTMLTitle", "Choose file to export to…" );
			this._langdict.Add( "HeadFile", "File" );
			this._langdict.Add( "HeadFirstFile", "First file" );
			this._langdict.Add( "HeadProperty", "Property" );
			this._langdict.Add( "HeadSecondFile", "Second file" );
			this._langdict.Add( "ImageExportError", "Image Export Error" );
			this._langdict.Add( "ImageGr", "Image" );
			this._langdict.Add( "ImageSaveAsBMP", "Bitmap image (*.bmp)" );
			this._langdict.Add( "ImageSaveAsJPG", "JPG image (*.jpg)" );
			this._langdict.Add( "ImageSaveAsPNG", "PNG image (*.png)" );
			this._langdict.Add( "ImageTitle", "Choose file to export to…" );
			this._langdict.Add( "ImgDFile", "Double files mode:" );
			this._langdict.Add( "ImgDFileMenuDate", "date && time (formatted)" );
			this._langdict.Add( "ImgDFileMenuFirstFull", "full first filename" );
			this._langdict.Add( "ImgDFileMenuFirstPath", "first file path" );
			this._langdict.Add( "ImgDFileMenuFirstShort", "short first filename" );
			this._langdict.Add( "ImgDFileMenuLine", "new line" );
			this._langdict.Add( "ImgDFileMenuSecondFull", "full second filename" );
			this._langdict.Add( "ImgDFileMenuSecondPath", "second file path" );
			this._langdict.Add( "ImgDFileMenuSecondShort", "short second filename" );
			this._langdict.Add( "ImgDFileMenuTab", "tabulation" );
			this._langdict.Add( "ImgDrawHead", "Draw additional header" );
			this._langdict.Add( "ImgGrColour", "Colour:" );
			this._langdict.Add( "ImgGrColourChangeBtn", "Change" );
			this._langdict.Add( "ImgGrFont", "Font:" );
			this._langdict.Add( "ImgGrFontChangeBtn", "Change" );
			this._langdict.Add( "ImgGrHeight", "Height:" );
			this._langdict.Add( "ImgGrWidth", "Width:" );
			this._langdict.Add( "ImgSFile", "Single file mode:" );
			this._langdict.Add( "ImgSFileMenuDate", "date && time (formatted)" );
			this._langdict.Add( "ImgSFileMenuFull", "full filename" );
			this._langdict.Add( "ImgSFileMenuLine", "new line" );
			this._langdict.Add( "ImgSFileMenuPath", "file path" );
			this._langdict.Add( "ImgSFileMenuShort", "short filename" );
			this._langdict.Add( "ImgSFileMenuTab", "tabulation" );
			this._langdict.Add( "ImgShowBtn", "Show" );
			this._langdict.Add( "ImgShowCloseBtn", "Close" );
			this._langdict.Add( "ImgShowDlgDFile", "Double files mode" );
			this._langdict.Add( "ImgShowDlgSFile", "Single file mode" );
			this._langdict.Add( "ImgShowDlgTitle", "Image header preview" );
			
			this._langdict.Add( "InfoTitle", "Info" );
			this._langdict.Add( "InfoContent", "----------------------------------------------\nGeneral\n----------------------------------------------\n\nComparer application is distributed under The Code Project Open Licence 1.02 (http://www.codeproject.com/info/cpol10.aspx).\n\nThe author holds no responsibility for any kind of data loss made by his applications.\n\nFeel free to provide any comments and suggestions sending them via e-mail to:\nmailto:fenixproductions@o2.pl\n\nPlease remember to add \"(Comparer)\" prefix (without quotes) to Subject field.\n\n----------------------------------------------\nSpecial thanks\n----------------------------------------------\n\nFor writing wdx_proxy.dll and agreement for using it, special thanks goes to:\n\nFranck8244\n\n----------------------------------------------\nCode snippets\n----------------------------------------------\n\nComplete Win32 INI File Utility Class\nhttp://www.codeproject.com/KB/files/win32fileutilityclass.aspx\n\nPlugins management class built thanks to Ankit Dass\nhttp://ankitdass.blogspot.com/2006/10/dynamically-calling-unmanaged-dll-from.html\n\nSourceGrid\nhttp://www.codeproject.com/KB/grid/csharpgridcontrol.aspx\n\nThe source code of Comparer tool is available on:\nhttp://fenixproductions.dcmembers.com/files/author.html" );

			this._langdict.Add( "IniNameUnknown", "<UNKNOWN>" );
			this._langdict.Add( "LangAuthor", "Author:" );
			this._langdict.Add( "LangFile", "File:" );
			this._langdict.Add( "LangTitle", "Language" );
			this._langdict.Add( "LangVersion", "Version:" );
			this._langdict.Add( "LanguageName", "English" );


			this._langdict.Add( "MsgBoxIniCantDelete", "Startup configuration file cannot be deleted!" );
			this._langdict.Add( "MsgBoxIniCreated", "Configuration file\\n%s\\nhas been created" );
			this._langdict.Add( "MsgBoxIniDeleted", "Configuration file:\\n\\n%s\\n\\nhas been deleted" );
			this._langdict.Add( "MsgBoxIniNotExist", "Specified configuration file does not exist!" );
			this._langdict.Add( "MsgBoxIniTrimInfo", "Configuration file already exist in \"configs\" folder!\\n\\nPlease remember that provided name has to be stripped from forbidden characters:\\n\\nspace %s\\n\\nMake sure it will be unique after that!" );
			this._langdict.Add( "MsgBoxTitleError", "Error" );
			this._langdict.Add( "MsgBoxTitleInfo", "Info" );
			this._langdict.Add( "MsgBoxTitleWarning", "Warning" );


			this._langdict.Add( "NoPlugins", "<NO PLUGINS>" );
			this._langdict.Add( "OKBtn", "OK" );
			this._langdict.Add( "OpenAfterExp", "Open output file after Export" );
			this._langdict.Add( "OptTitle", "Options" );
			this._langdict.Add( "Parameters", "Parameters:" );
			this._langdict.Add( "ParametersHint", "(use %f1 as first filename and %f2 as second filename)" );
			this._langdict.Add( "PlugsDefPath", "Default plugins path:" );
			this._langdict.Add( "PlugsPathDlg", "Choose default plugins path" );
			this._langdict.Add( "PlugsScanBtn", "Scan for plugins" );
			this._langdict.Add( "RowAccess", "Access" );
			this._langdict.Add( "RowAttributes", "Attributes" );
			this._langdict.Add( "RowCreated", "Created" );
			this._langdict.Add( "RowGeneral", "General" );
			this._langdict.Add( "RowName", "Name" );
			this._langdict.Add( "RowPath", "Path" );
			this._langdict.Add( "RowSize", "Size" );
			this._langdict.Add( "RowThumbnail", "Thumbnail" );
			this._langdict.Add( "RowWrite", "Write" );
			this._langdict.Add( "SFileMenuDate", "date && time (formatted)" );
			this._langdict.Add( "SFileMenuFull", "full filename" );
			this._langdict.Add( "SFileMenuShort", "short filename" );
			this._langdict.Add( "SetFieldsBtn", "Set fields" );
			this._langdict.Add( "ShowBtn", "Show" );
			this._langdict.Add( "ShowDlgCloseBtn", "Close" );
			this._langdict.Add( "ShowDlgDFile", "Double files mode" );
			this._langdict.Add( "ShowDlgDoubleOut", "Output:" );
			this._langdict.Add( "ShowDlgError", "Filename empty or contains invalid characters!" );
			this._langdict.Add( "ShowDlgFile", "File:" );
			this._langdict.Add( "ShowDlgFirst", "First file:" );
			this._langdict.Add( "ShowDlgFirstOut", "Output:" );
			this._langdict.Add( "ShowDlgSFile", "Single file mode" );
			this._langdict.Add( "ShowDlgSecond", "Second file:" );
			this._langdict.Add( "ShowDlgTitle", "Output names preview" );
			this._langdict.Add( "SingleFile", "Single file mode:" );
			this._langdict.Add( "TBCompare", "&Compare" );
			this._langdict.Add( "TBCompareTip", "External tool compare" );
			this._langdict.Add( "TBConfigLabel", "Config:" );
			this._langdict.Add( "TBConfigCBStart", " (startup)" );
			this._langdict.Add( "TBExport", "&Export" );
			this._langdict.Add( "TBExportMenuCSV", "CSV" );
			this._langdict.Add( "TBExportMenuHTML", "HTML" );
			this._langdict.Add( "TBExportMenuImage", "Image" );
			this._langdict.Add( "TBExportTip", "Export details" );
			this._langdict.Add( "TBOptions", "&Options" );
			this._langdict.Add( "TBOptionsTip", "Configure application" );
			this._langdict.Add( "TBStickMode", "&Stick mode" );
			this._langdict.Add( "TBStickModeTip", "Stick mode" );
			this._langdict.Add( "ThViewGr", "Thumbnails view" );
			this._langdict.Add( "ThViewHeight", "Height:" );
			this._langdict.Add( "ThViewIcons", "Show icons for empty thumbnails" );
			this._langdict.Add( "ThViewShow", "Show thumbnails" );			
			this._langdict.Add( "Version", "1.0.6.0" );
			this._langdict.Add( "VisEmpty", "Show empty / error nodes" );
			this._langdict.Add( "VisGr", "Visibility" );
			this._langdict.Add( "VisOnlyDiff", "Show only different" );
			this._langdict.Add( "VisWrap", "Wrap text in cells" );
			this._langdict.Add( "WDXDownBtn", "Down" );
			this._langdict.Add( "WDXExtensionsGr", "Extensions (ex. *.bmp *.jpg)" );
			this._langdict.Add( "WDXPluginDlgTitle", "Choose WDX content plugin" );
			this._langdict.Add( "WDXPluginDlgType", "Content plugins (*.wdx)" );
			this._langdict.Add( "WDXPluginGr", "Plugin" );
			this._langdict.Add( "WDXTitle", "Plugins (WDX)" );
			this._langdict.Add( "WDXUpBtn", "Up" );
			this._langdict.Add( "WLXDownBtn", "Down" );
			this._langdict.Add( "WLXExtensionsGr", "Extensions (ex. *.bmp *.jpg)" );
			this._langdict.Add( "WLXPluginDlgTitle", "Choose WLX lister plugin" );
			this._langdict.Add( "WLXPluginDlgType", "Lister plugins (*.wlx)" );
			this._langdict.Add( "WLXPluginGr", "Plugin" );
			this._langdict.Add( "WLXTitle", "Plugins (WLX)" );
			this._langdict.Add( "WLXUpBtn", "Up" );
		}

		private void ReadLangFile(string langfile)
		{
			IniFile inif = new IniFile( langfile );

			//inif.GetString( "sekcja", "klucz", "default" );
			//this._langdict.Add( "XXX", "Always on top" );
			this._langdict.Add( "LanguageName", inif.GetString( "Language", "LanguageName", "default (English)" ) );
			this._langdict.Add( "Author", inif.GetString( "Language", "Author", "fenixproductions" ) );
			this._langdict.Add( "Language", inif.GetString( "Language", "Version", "1.0.6.0" ) );

			this._langdict.Add( "TBCompare", inif.GetString( "MainForm", "TBCompare", "&Compare" ) );
			this._langdict.Add( "TBCompareTip", inif.GetString( "MainForm", "TBCompareTip", "External tool compare" ) );
			this._langdict.Add( "TBExport", inif.GetString( "MainForm", "TBExport", "&Export" ) );
			this._langdict.Add( "TBExportTip", inif.GetString( "MainForm", "TBExportTip", "Export details" ) );
			this._langdict.Add( "TBExportMenuCSV", inif.GetString( "MainForm", "TBExportMenuCSV", "CSV" ) );
			this._langdict.Add( "TBExportMenuHTML", inif.GetString( "MainForm", "TBExportMenuHTML", "HTML" ) );
			this._langdict.Add( "TBExportMenuImage", inif.GetString( "MainForm", "TBExportMenuImage", "Image" ) );
			this._langdict.Add( "TBStickMode", inif.GetString( "MainForm", "TBStickMode", "&Stick mode" ) );
			this._langdict.Add( "TBStickModeTip", inif.GetString( "MainForm", "TBStickModeTip", "Stick mode" ) );
			this._langdict.Add( "TBOptions", inif.GetString( "MainForm", "TBOptions", "&Options" ) );
			this._langdict.Add( "TBOptionsTip", inif.GetString( "MainForm", "TBOptionsTip", "Configure application" ) );
			this._langdict.Add( "TBConfigLabel", inif.GetString( "MainForm", "TBConfigLabel", "Config:" ) );
			this._langdict.Add( "TBConfigCBStart", inif.GetString( "MainForm", "TBConfigCBStart", " (startup)" ) );
			this._langdict.Add( "IniNameUnknown", inif.GetString( "MainForm", "IniNameUnknown", "<UNKNOWN>" ) );
			this._langdict.Add( "DefaultName", inif.GetString( "MainForm", "DefaultName", "default" ) );


			this._langdict.Add( "MsgBoxTitleError", inif.GetString( "MsgBoxes", "MsgBoxTitleError", "Error" ) );
			this._langdict.Add( "MsgBoxTitleInfo", inif.GetString( "MsgBoxes", "MsgBoxTitleInfo", "Info" ) );
			this._langdict.Add( "MsgBoxTitleWarning", inif.GetString( "MsgBoxes", "MsgBoxTitleWarning", "Warning" ) );
			this._langdict.Add( "MsgBoxIniNotExist", inif.GetString( "MsgBoxes", "MsgBoxIniNotExist", "Specified configuration file does not exist!" ) );
			this._langdict.Add( "MsgBoxIniCantDelete", inif.GetString( "MsgBoxes", "MsgBoxIniCantDelete", "Startup configuration file cannot be deleted!" ) );
			this._langdict.Add( "MsgBoxIniDeleted", inif.GetString( "MsgBoxes", "MsgBoxIniDeleted", "Configuration file:\\n\\n%s\\n\\nhas been deleted" ) );
			this._langdict.Add( "MsgBoxIniCreated", inif.GetString( "MsgBoxes", "MsgBoxIniCreated", "Configuration file\\n%s\\nhas been created" ) );
			this._langdict.Add( "MsgBoxIniTrimInfo", inif.GetString( "MsgBoxes", "MsgBoxIniTrimInfo", "Configuration file already exist in \"configs\" folder!\\n\\nPlease remember that provided name has to be stripped from forbidden characters:\\n\\nspace %s\\n\\nMake sure it will be unique after that!" ) );


			this._langdict.Add( "HeadProperty", inif.GetString( "Table", "HeadProperty", "Property" ) );
			this._langdict.Add( "HeadFile", inif.GetString( "Table", "HeadFile", "File" ) );
			this._langdict.Add( "HeadFirstFile", inif.GetString( "Table", "HeadFirstFile", "First file" ) );
			this._langdict.Add( "HeadSecondFile", inif.GetString( "Table", "HeadSecondFile", "Second file" ) );
			this._langdict.Add( "RowGeneral", inif.GetString( "Table", "RowGeneral", "General" ) );
			this._langdict.Add( "RowThumbnail", inif.GetString( "Table", "RowThumbnail", "Thumbnail" ) );
			this._langdict.Add( "RowName", inif.GetString( "Table", "RowName", "Name" ) );
			this._langdict.Add( "RowPath", inif.GetString( "Table", "RowPath", "Path" ) );
			this._langdict.Add( "RowSize", inif.GetString( "Table", "RowSize", "Size" ) );
			this._langdict.Add( "RowAttributes", inif.GetString( "Table", "RowAttributes", "Attributes" ) );
			this._langdict.Add( "RowCreated", inif.GetString( "Table", "RowCreated", "Created" ) );
			this._langdict.Add( "RowAccess", inif.GetString( "Table", "RowAccess", "Access" ) );
			this._langdict.Add( "RowWrite", inif.GetString( "Table", "RowWrite", "Write" ) );
			this._langdict.Add( "NoPlugins", inif.GetString( "Table", "NoPlugins", "<NO PLUGINS>" ) );
			this._langdict.Add( "EmptyError", inif.GetString( "Table", "EmptyError", "<EMPTY / ERROR>" ) );
			this._langdict.Add( "ByteSuffix", inif.GetString( "Table", "ByteSuffix", " b" ) );

			this._langdict.Add( "CSVTitle", inif.GetString( "ExportDialog", "CSVTitle", "Choose file to export to…" ) );
			this._langdict.Add( "CSVSaveAs", inif.GetString( "ExportDialog", "CSVSaveAs", "CSV files (*.cvs)" ) );
			this._langdict.Add( "CSVExportError", inif.GetString( "ExportDialog", "CSVExportError", "CSV Export Error!" ) );
			this._langdict.Add( "ExportErrorPerm", inif.GetString( "ExportDialog", "ExportErrorPerm", "You don't have permission to write to this file!" ) );
			this._langdict.Add( "HTMLTitle", inif.GetString( "ExportDialog", "HTMLTitle", "Choose file to export to…" ) );
			this._langdict.Add( "HTMLSaveAs", inif.GetString( "ExportDialog", "HTMLSaveAs", "HTML files (*.html)" ) );
			this._langdict.Add( "HTMLExportError", inif.GetString( "ExportDialog", "HTMLExportError", "HTML Export Error" ) );
			this._langdict.Add( "ImageTitle", inif.GetString( "ExportDialog", "ImageTitle", "Choose file to export to…" ) );
			this._langdict.Add( "ImageSaveAsBMP", inif.GetString( "ExportDialog", "ImageSaveAsBMP", "Bitmap image (*.bmp)" ) );
			this._langdict.Add( "ImageSaveAsJPG", inif.GetString( "ExportDialog", "ImageSaveAsJPG", "JPG image (*.jpg)" ) );
			this._langdict.Add( "ImageSaveAsPNG", inif.GetString( "ExportDialog", "ImageSaveAsPNG", "PNG image (*.png)" ) );
			this._langdict.Add( "ImageExportError", inif.GetString( "ExportDialog", "ImageExportError", "Image Export Error" ) );

			this._langdict.Add( "OptTitle", inif.GetString( "OptionsForm", "OptTitle", "Options" ) );
			this._langdict.Add( "OKBtn", inif.GetString( "OptionsForm", "OKBtn", "OK" ) );
			this._langdict.Add( "CancelBtn", inif.GetString( "OptionsForm", "CancelBtn", "Cancel" ) );

			this._langdict.Add( "GenTitle", inif.GetString( "GeneralTab", "GenTitle", "General" ) );
			this._langdict.Add( "AppWinGr", inif.GetString( "GeneralTab", "AppWinGr", "Main window" ) );
			this._langdict.Add( "AppWinSize", inif.GetString( "GeneralTab", "AppWinSize", "Remember size" ) );
			this._langdict.Add( "AppWinResetBtn", inif.GetString( "GeneralTab", "AppWinResetBtn", "Reset to default" ) );
			this._langdict.Add( "AppWinAlwaysTop", inif.GetString( "GeneralTab", "AppWinAlwaysTop", "Always on top" ) );
			this._langdict.Add( "AppWinCloseCompare", inif.GetString( "GeneralTab", "AppWinCloseCompare", "Close application after starting compare tool" ) );
			this._langdict.Add( "AppWinStickMode", inif.GetString( "GeneralTab", "AppWinStickMode", "Stick mode by default" ) );
			this._langdict.Add( "LangTitle", inif.GetString( "GeneralTab", "LangTitle", "Language" ) );
			this._langdict.Add( "LangAuthor", inif.GetString( "GeneralTab", "LangAuthor", "Author:" ) );
			this._langdict.Add( "LangVersion", inif.GetString( "GeneralTab", "LangVersion", "Version:" ) );
			this._langdict.Add( "LangFile", inif.GetString( "GeneralTab", "LangFile", "File:" ) );
			
			this._langdict.Add( "ThViewGr", inif.GetString( "GeneralTab", "ThViewGr", "Thumbnails view" ) );
			this._langdict.Add( "ThViewShow", inif.GetString( "GeneralTab", "ThViewShow", "Show thumbnails" ) );
			this._langdict.Add( "ThViewHeight", inif.GetString( "GeneralTab", "ThViewHeight", "Height:" ) );
			this._langdict.Add( "ThViewIcons", inif.GetString( "GeneralTab", "ThViewIcons", "Show icons for empty thumbnails" ) );
			this._langdict.Add( "VisGr", inif.GetString( "GeneralTab", "VisGr", "Visibility" ) );
			this._langdict.Add( "VisOnlyDiff", inif.GetString( "GeneralTab", "VisOnlyDiff", "Show only different" ) );
			this._langdict.Add( "VisEmpty", inif.GetString( "GeneralTab", "VisEmpty", "Show empty / error nodes" ) );
			this._langdict.Add( "VisWrap", inif.GetString( "GeneralTab", "VisWrap", "Wrap text in cells" ) );
			
			this._langdict.Add( "PlugsDefGr", inif.GetString( "GeneralTab", "PlugsDefGr", "Plugins" ) );
			this._langdict.Add( "PlugsDefPath", inif.GetString( "GeneralTab", "PlugsDefPath", "Default plugins path:" ) );
			this._langdict.Add( "PlugsScanBtn", inif.GetString( "GeneralTab", "PlugsScanBtn", "Scan for plugins" ) );
			this._langdict.Add( "PlugsPathDlg", inif.GetString( "GeneralTab", "PlugsPathDlg", "Choose default plugins path" ) );

			this._langdict.Add( "WDXTitle", inif.GetString( "WDXPlugsTab", "WDXTitle", "Plugins (WDX)" ) );
			this._langdict.Add( "WDXUpBtn", inif.GetString( "WDXPlugsTab", "WDXUpBtn", "Up" ) );
			this._langdict.Add( "WDXDownBtn", inif.GetString( "WDXPlugsTab", "WDXDownBtn", "Down" ) );
			this._langdict.Add( "WDXPluginGr", inif.GetString( "WDXPlugsTab", "WDXPluginGr", "Plugin" ) );
			this._langdict.Add( "WDXPluginDlgTitle", inif.GetString( "WDXPlugsTab", "WDXPluginDlgTitle", "Choose WDX content plugin" ) );
			this._langdict.Add( "WDXPluginDlgType", inif.GetString( "WDXPlugsTab", "WDXPluginDlgType", "Content plugins (*.wdx)" ) );
			this._langdict.Add( "WDXExtensionsGr", inif.GetString( "WDXPlugsTab", "WDXExtensionsGr", "Extensions (ex. *.bmp *.jpg)" ) );
			this._langdict.Add( "SetFieldsBtn", inif.GetString( "WDXPlugsTab", "SetFieldsBtn", "Set fields" ) );
			this._langdict.Add( "FieldsFormTitle", inif.GetString( "WDXPlugsTab", "FieldsFormTitle", "Choose fields" ) );
			this._langdict.Add( "FieldsFormDesc", inif.GetString( "WDXPlugsTab", "FieldsFormDesc", "Choose plugin's fields to be shown" ) );
			this._langdict.Add( "FieldsFormOK", inif.GetString( "WDXPlugsTab", "FieldsFormOK", "OK" ) );
			this._langdict.Add( "FieldsFormCancel", inif.GetString( "WDXPlugsTab", "FieldsFormCancel", "Cancel" ) );

			this._langdict.Add( "WLXTitle", inif.GetString( "WLXPlugsTab", "WLXTitle", "Plugins (WLX)" ) );
			this._langdict.Add( "WLXUpBtn", inif.GetString( "WLXPlugsTab", "WLXUpBtn", "Up" ) );
			this._langdict.Add( "WLXDownBtn", inif.GetString( "WLXPlugsTab", "WLXDownBtn", "Down" ) );
			this._langdict.Add( "WLXPluginGr", inif.GetString( "WLXPlugsTab", "WLXPluginGr", "Plugin" ) );
			this._langdict.Add( "WLXPluginDlgTitle", inif.GetString( "WLXPlugsTab", "WLXPluginDlgTitle", "Choose WLX lister plugin" ) );
			this._langdict.Add( "WLXPluginDlgType", inif.GetString( "WLXPlugsTab", "WLXPluginDlgType", "Lister plugins (*.wlx)" ) );
			this._langdict.Add( "WLXExtensionsGr", inif.GetString( "WLXPlugsTab", "WLXExtensionsGr", "Extensions (ex. *.bmp *.jpg)" ) );

			this._langdict.Add( "CmpTitle", inif.GetString( "ComparersTab", "CmpTitle", "Comparers" ) );
			this._langdict.Add( "CmpUpBtn", inif.GetString( "ComparersTab", "CmpUpBtn", "Up" ) );
			this._langdict.Add( "CmpDownBtn", inif.GetString( "ComparersTab", "CmpDownBtn", "Down" ) );
			this._langdict.Add( "ExecutableGr", inif.GetString( "ComparersTab", "ExecutableGr", "Executable" ) );
			this._langdict.Add( "ExecutableDlgTitle", inif.GetString( "ComparersTab", "ExecutableDlgTitle", "Choose comparer tool EXE file" ) );
			this._langdict.Add( "ExecutableDlgType", inif.GetString( "ComparersTab", "ExecutableDlgType", "Executable files (*.exe)" ) );
			this._langdict.Add( "Parameters", inif.GetString( "ComparersTab", "Parameters", "Parameters:" ) );
			this._langdict.Add( "ParametersHint", inif.GetString( "ComparersTab", "ParametersHint", "(use %f1 as first filename and %f2 as second filename)" ) );
			this._langdict.Add( "CmpExtensionsGr", inif.GetString( "ComparersTab", "CmpExtensionsGr", "Extensions (ex. *.bmp *.jpg)" ) );

			this._langdict.Add( "ExportTitle", inif.GetString( "ExportTab", "ExportTitle", "Export" ) );
			this._langdict.Add( "FilenamesGr", inif.GetString( "ExportTab", "FilenamesGr", "Default filenames (without extensions)" ) );
			this._langdict.Add( "SingleFile", inif.GetString( "ExportTab", "SingleFile", "Single file mode:" ) );
			this._langdict.Add( "DoubleFile", inif.GetString( "ExportTab", "DoubleFile", "Double files mode:" ) );
			this._langdict.Add( "SFileMenuShort", inif.GetString( "ExportTab", "SFileMenuShort", "short filename" ) );
			this._langdict.Add( "SFileMenuFull", inif.GetString( "ExportTab", "SFileMenuFull", "full filename" ) );
			this._langdict.Add( "SFileMenuDate", inif.GetString( "ExportTab", "SFileMenuDate", "date && time (formatted)" ) );
			this._langdict.Add( "DFileMenuFirstShort", inif.GetString( "ExportTab", "DFileMenuFirstShort", "short first filename" ) );
			this._langdict.Add( "DFileMenuFirstFull", inif.GetString( "ExportTab", "DFileMenuFirstFull", "full first filename" ) );
			this._langdict.Add( "DFileMenuSecondShort", inif.GetString( "ExportTab", "DFileMenuSecondShort", "short second filename" ) );
			this._langdict.Add( "DFileMenuSecondFull", inif.GetString( "ExportTab", "DFileMenuSecondFull", "full second filename" ) );
			this._langdict.Add( "DFileMenuDate", inif.GetString( "ExportTab", "DFileMenuDate", "date && time (formatted)" ) );
			this._langdict.Add( "ShowBtn", inif.GetString( "ExportTab", "ShowBtn", "Show" ) );
			this._langdict.Add( "ShowDlgTitle", inif.GetString( "ExportTab", "ShowDlgTitle", "Output names preview" ) );
			this._langdict.Add( "ShowDlgSFile", inif.GetString( "ExportTab", "ShowDlgSFile", "Single file mode" ) );
			this._langdict.Add( "ShowDlgFile", inif.GetString( "ExportTab", "ShowDlgFile", "File:" ) );
			this._langdict.Add( "ShowDlgFirstOut", inif.GetString( "ExportTab", "ShowDlgFirstOut", "Output:" ) );
			this._langdict.Add( "ShowDlgDFile", inif.GetString( "ExportTab", "ShowDlgDFile", "Double files mode" ) );
			this._langdict.Add( "ShowDlgFirst", inif.GetString( "ExportTab", "ShowDlgFirst", "First file:" ) );
			this._langdict.Add( "ShowDlgSecond", inif.GetString( "ExportTab", "ShowDlgSecond", "Second file:" ) );
			this._langdict.Add( "ShowDlgDoubleOut", inif.GetString( "ExportTab", "ShowDlgDoubleOut", "Output:" ) );
			this._langdict.Add( "ShowDlgCloseBtn", inif.GetString( "ExportTab", "ShowDlgCloseBtn", "Close" ) );
			this._langdict.Add( "ShowDlgError", inif.GetString( "ExportTab", "ShowDlgError", "Filename empty or contains invalid characters!" ) );

			this._langdict.Add( "CSVGr", inif.GetString( "ExportTab", "CSVGr", "CSV" ) );
			this._langdict.Add( "CSVSeparator", inif.GetString( "ExportTab", "CSVSeparator", "Separator:" ) );
			this._langdict.Add( "CSVSurround", inif.GetString( "ExportTab", "CSVSurround", "Surround text with quotes (\")" ) );
			this._langdict.Add( "ImageGr", inif.GetString( "ExportTab", "ImageGr", "Image" ) );
			this._langdict.Add( "ImgDrawHead", inif.GetString( "ExportTab", "ImgDrawHead", "Draw additional header" ) );
			this._langdict.Add( "ImgSFile", inif.GetString( "ExportTab", "ImgSFile", "Single file mode:" ) );
			this._langdict.Add( "ImgSFileMenuShort", inif.GetString( "ExportTab", "ImgSFileMenuShort", "short filename" ) );
			this._langdict.Add( "ImgSFileMenuFull", inif.GetString( "ExportTab", "ImgSFileMenuFull", "full filename" ) );
			this._langdict.Add( "ImgSFileMenuPath", inif.GetString( "ExportTab", "ImgSFileMenuPath", "file path" ) );
			this._langdict.Add( "ImgSFileMenuDate", inif.GetString( "ExportTab", "ImgSFileMenuDate", "date && time (formatted)" ) );
			this._langdict.Add( "ImgSFileMenuLine", inif.GetString( "ExportTab", "ImgSFileMenuLine", "new line" ) );
			this._langdict.Add( "ImgSFileMenuTab", inif.GetString( "ExportTab", "ImgSFileMenuTab", "tabulation" ) );
			this._langdict.Add( "ImgDFile", inif.GetString( "ExportTab", "ImgDFile", "Double files mode:" ) );
			this._langdict.Add( "ImgDFileMenuFirstShort", inif.GetString( "ExportTab", "ImgDFileMenuFirstShort", "short first filename" ) );
			this._langdict.Add( "ImgDFileMenuFirstFull", inif.GetString( "ExportTab", "ImgDFileMenuFirstFull", "full first filename" ) );
			this._langdict.Add( "ImgDFileMenuFirstPath", inif.GetString( "ExportTab", "ImgDFileMenuFirstPath", "first file path" ) );
			this._langdict.Add( "ImgDFileMenuSecondShort", inif.GetString( "ExportTab", "ImgDFileMenuSecondShort", "short second filename" ) );
			this._langdict.Add( "ImgDFileMenuSecondFull", inif.GetString( "ExportTab", "ImgDFileMenuSecondFull", "full second filename" ) );
			this._langdict.Add( "ImgDFileMenuSecondPath", inif.GetString( "ExportTab", "ImgDFileMenuSecondPath", "second file path" ) );
			this._langdict.Add( "ImgDFileMenuDate", inif.GetString( "ExportTab", "ImgDFileMenuDate", "date && time (formatted)" ) );
			this._langdict.Add( "ImgDFileMenuLine", inif.GetString( "ExportTab", "ImgDFileMenuLine", "new line" ) );
			this._langdict.Add( "ImgDFileMenuTab", inif.GetString( "ExportTab", "ImgDFileMenuTab", "tabulation" ) );
			this._langdict.Add( "ImgShowBtn", inif.GetString( "ExportTab", "ImgShowBtn", "Show" ) );
			this._langdict.Add( "ImgShowDlgTitle", inif.GetString( "ExportTab", "ImgShowDlgTitle", "Image header preview" ) );
			this._langdict.Add( "ImgShowDlgSFile", inif.GetString( "ExportTab", "ImgShowDlgSFile", "Single file mode" ) );
			this._langdict.Add( "ImgShowDlgDFile", inif.GetString( "ExportTab", "ImgShowDlgDFile", "Double files mode" ) );
			this._langdict.Add( "ImgShowCloseBtn", inif.GetString( "ExportTab", "ImgShowCloseBtn", "Close" ) );
			this._langdict.Add( "ImgGrWidth", inif.GetString( "ExportTab", "ImgGrWidth", "Width:" ) );
			this._langdict.Add( "ImgGrHeight", inif.GetString( "ExportTab", "ImgGrHeight", "Height:" ) );
			this._langdict.Add( "ImgGrFont", inif.GetString( "ExportTab", "ImgGrFont", "Font:" ) );
			this._langdict.Add( "ImgGrFontChangeBtn", inif.GetString( "ExportTab", "ImgGrFontChangeBtn", "Change" ) );
			this._langdict.Add( "ImgGrColour", inif.GetString( "ExportTab", "ImgGrColour", "Colour:" ) );
			this._langdict.Add( "ImgGrColourChangeBtn", inif.GetString( "ExportTab", "ImgGrColourChangeBtn", "Change" ) );
			this._langdict.Add( "OpenAfterExp", inif.GetString( "ExportTab", "OpenAfterExp", "Open output file after Export" ) );
			this._langdict.Add( "DateFormatInfo", inif.GetString( "ExportTab", "DateFormatInfo", "Date formatting info" ) );
			this._langdict.Add( "InfoTitle", inif.GetString( "InfoTab", "InfoTitle", "Info" ) );
			this._langdict.Add( "InfoContent", inif.GetString( "InfoTab", "InfoContent", "----------------------------------------------\nGeneral\n----------------------------------------------\n\nComparer application is distributed under The Code Project Open Licence 1.02 (http://www.codeproject.com/info/cpol10.aspx).\n\nThe author holds no responsibility for any kind of data loss made by his applications.\n\nFeel free to provide any comments and suggestions sending them via e-mail to:\nmailto:fenixproductions@o2.pl\n\nPlease remember to add \"(Comparer)\" prefix (without quotes) to Subject field.\n\n----------------------------------------------\nSpecial thanks\n----------------------------------------------\n\nFor writing wdx_proxy.dll and agreement for using it, special thanks goes to:\n\nFranck8244\n\n----------------------------------------------\nCode snippets\n----------------------------------------------\n\nComplete Win32 INI File Utility Class\nhttp://www.codeproject.com/KB/files/win32fileutilityclass.aspx\n\nPlugins management class built thanks to Ankit Dass\nhttp://ankitdass.blogspot.com/2006/10/dynamically-calling-unmanaged-dll-from.html\n\nSourceGrid\nhttp://www.codeproject.com/KB/grid/csharpgridcontrol.aspx\n\nThe source code of Comparer tool is available on:\nhttp://fenixproductions.dcmembers.com/files/author.html" ) );
		}
	}
}
