﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Drawing;

namespace Comparer
{
	public delegate void MyUpdaterEventHandler( object sender, int nr, Bitmap pict, Boolean isicon );

	class ThumbStarter
	{
		private ThreadStart _t1start;
		private Thread _t1;
		private ThreadStart _t2start;
		private Thread _t2;
		private ThreadStart _tstart;
		private Thread _t;

		public Image pict1;
		public Image pict2;
		public Boolean icon1;
		public Boolean icon2;

		public ThumbStarter()
		{
			pict1 = null;
			pict2 = null;
			icon1 = false;
			icon2 = false;
		}

		public void StartProcedure(String filename, int wid1, int thhei, List<String> lista)
		{
			icon1 = false;
			icon2 = false;

			ThumbGenerator tb = new ThumbGenerator( filename, wid1, thhei, lista, 1 );
			tb.UpdateLabel += new MyUpdaterEventHandler( UpdateLabel );

			_tstart = new ThreadStart( tb.GiveThumb );
			_t = new Thread( _tstart );
			_t.IsBackground = true;
			_t.Start();
			_t.Join();
		}

		public void StartProcedures(string filename1, String filename2, int wid1, int wid2, int thhei, List<String> lista, List<String> lista2 )
		{
			icon1 = false;
			icon2 = false;
			ThumbGenerator tb1 = new ThumbGenerator( filename1, wid1, thhei, lista, 1 );
			tb1.UpdateLabel += new MyUpdaterEventHandler( UpdateLabel );

			//ThreadStart t1start = new ThreadStart( tb1.GiveThumb );
			//Thread t1 = new Thread( t1start );
			_t1start = new ThreadStart( tb1.GiveThumb );
			_t1 = new Thread( _t1start );
			_t1.IsBackground = true;
			_t1.Start();
						
			ThumbGenerator tb2 = new ThumbGenerator( filename2, wid2, thhei, lista2, 2 );
			tb2.UpdateLabel += new MyUpdaterEventHandler( UpdateLabel );
			
			_t2start = new ThreadStart( tb2.GiveThumb );
			_t2 = new Thread( _t2start );
			_t2.IsBackground = true;
			_t2.Start();

			_t1.Join();
			_t2.Join();
		}

		public void UpdateLabel( object sender, int numer, Bitmap bmp, Boolean ikona )
		{
			switch (numer)
			{
				case 1:					
					if (bmp != null)
					{
						pict1 = bmp;
					}
					icon1 = ikona;
					break;
				case 2:
					if (bmp != null)
					{
						pict2 = bmp;
					}
					icon2 = ikona;
					break;
				default:
					break;
			}

		}

		public void CleanThreads()
		{
			if (_t != null)
			{
				if (_t.IsAlive)
				{
					_t.Abort();
				}
			}
			if (_t1 != null)
			{
				if (_t1.IsAlive)
				{
					_t1.Abort();
				}
			}
			if (_t2 != null)
			{
				if (_t2.IsAlive)
				{
					_t2.Abort();
				}
			}
		}
	}
}
